---
title: Home
page_id: "home.00"
---

## <i class="fa fa-bolt" aria-hidden="true"></i> Small but Powerful and Efficient

TreeFrog Framework is a high-speed and full-stack C++ framework for developing Web applications, which supports HTTP and WebSocket protocol.

Web applications can run faster than that of scripting language because the server-side framework was written in C++/Qt. In application development, it provides an O/R mapping system and template systems on an MVC architecture, aims to achieve high productivity through the policy of  convention over configuration.


## <i class="fa fa-flag" aria-hidden="true"></i> Features

  1. High performance - Highly optimized Application server engine of C++.
  2. O/R mapping  - Conceals complex and troublesome database accesses
  3. Template system  - ERB-like template engine
  4. Support for many DB - MySQL, PostgreSQL, ODBC, SQLite, MongoDB, Redis, etc.
  5. Cross-platform  - Same source code can work on Windows, macOS and Linux
  6. Support WebSocket - Providing full-duplex communications channels
  7. Generator - Automatically generates scaffolds and Makefiles
  8. Less resource -  Stable operation even on Raspberry Pi
  9. OSS  - New BSD License


## <i class="fa fa-comment" aria-hidden="true"></i> Selecting TreeFrog Framework

It is said that there is a trade-off relationship between development efficiency and operation speed in web application development, is it really true?

There is not such a thing. it is possible to develop efficiently by providing convenient development tools and excellent libraries from the framework and by specifying specifications to minimize the configuration file.

In recent years, cloud computing has emerged, the importance of Web applications is increasing year by year. Although it is known that the execution speed of the script language decreases as the amount of code increases, C++ language can operate at the fastest speed with a small memory footprint and does not decrease execution speed even as the amount of code increases.

Multiple application servers running in scripting language can be aggregated into one without degrading performance.
Try TreeFrog Framework which combines high productivity and high speed operation!


## <i class="fa fa-bell" aria-hidden="true"></i> News

Jun. 10, 2018

### TreeFrog Framework version 1.22.0 (stable) release <span style="color: red;">New!</span>

  - Support for CMake build of Web application.
  - Support SMTP connections to older servers not supporting ESMTP.
  - Fix bugs of tspawn.pro file.

  [<i class="fa fa-hand-o-right" aria-hidden="true"></i> Download this version](/en/download/)

Mar. 25, 2018

### TreeFrog Framework version 1.21.0 (stable) release

  - Added the option of linking the shared mongoc library.
  - Fix a bug of line endings of HTTP headers on Windows.
  - Fix a bug of reloading app libraries.
  - Fix to return 404 when the action is not found.

Dec. 9, 2017

### TreeFrog Framework version 1.20.0 (stable) release

  - Implemented rawBody() function in THttpRequest class.
  - Added some functions for getting query string.
  - Added sql statements to PostOpenStatements in database.ini.
  - Fix compilation error on Ubuntu 17.10 and macOS.
  - Fix compilation error on Qt 5.10.

Sep. 20, 2017

### TreeFrog Framework version 1.19.0 (stable) release

  - Added TSqlDriverExtension class for upsert statement.
  - Added QString arguments to sort columns function.
  - Added routes.cfg settings by which redirecting to URL path.
  - Modified to send a message of empty body when the status code is 304.
  - Fix compilation error on FreeBSD.
  - Other bugfixes.

 [<i class="fa fa-list" aria-hidden="true"></i> All changelogs](https://github.com/treefrogframework/treefrog-framework/blob/master/CHANGELOG.md)


## <i class="fa fa-user" aria-hidden="true"></i> Wanted

 - Developers, testers, translators.

Since this site is built with [GitHub Pages](https://pages.github.com/), translations can also be sent by a pull-request.
Visit [GitHub](https://github.com/treefrogframework/treefrog-framework){:target="_blank"}. Welcome!

## <i class="fa fa-info-circle" aria-hidden="true"></i> Information

[TreeFrog forum](https://groups.google.com/forum/#!forum/treefrogframework){:target="_blank"}

Twitter [@TreeFrog_ja](https://twitter.com/TreeFrog_ja){:target="_blank"}

Docker Images [(external link)](https://hub.docker.com/r/treefrogframework/treefrog/){:target="_blank"}

Benchmarks [(external link)](https://www.techempower.com/benchmarks/#section=data-r16){:target="_blank"}
